package com.kingdee.shr.customer.gtiit.osf;

import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.bsf.service.app.IHRMsfService;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.util.app.DbUtil;
import com.kingdee.jdbc.rowset.IRowSet;
import com.kingdee.util.DateTimeUtils;
import org.apache.commons.lang3.StringUtils;
import org.apache.log4j.Logger;

import java.math.BigDecimal;
import java.text.ParseException;
import java.time.LocalDate;
import java.time.ZoneId;
import java.time.format.DateTimeFormatter;
import java.util.*;

/**
 * description: RetMoneyService <br>
 * date: 2025/4/21 10:37 <br>
 * author: lhbj <br>
 * version: 1.0 <br>
 */
public class RetMoneyService implements IHRMsfService {
    // ־¼
    private static Logger logger = Logger.getLogger("com.kingdee.shr.customer.gtiit.osf.RetMoneyService");

    @Override
    public Object process(Context ctx, Map<String, Object> map) throws EASBizException, BOSException {
        try {
            String sql = "\n" +
                    " /*dialect*/SELECT FMONEY ,FID ,FPERSONID ,FCMPITEMID,FEFFECTDAY ,FLEFFECTDAY,CFTraceability,CFRetroactiveDate,foldfixadjustsalaryid \n" +
                    " FROM T_HR_SFixAdjustSalary where sysdate between  FEFFECTDAY and FLEFFECTDAY \n" +
                    " and CFTraceability='Yes' and FEFFECTDAY < cfretroactivedate ";
            HashSet<String> list = new HashSet<>(); // ڴ洢нʵ¼ID
            logger.error("sql" + sql); // ¼SQLѯ䵽־
            IRowSet rs = DbUtil.executeQuery(ctx, sql); // ִSQLѯȡ
            while (rs.next()) {
                BigDecimal sumMoney = BigDecimal.ZERO; // ʼнܶΪ0
                BigDecimal money = rs.getBigDecimal("FMONEY"); // ȡǰ¼нʵ
                Date cfretroactivedate = new Date(rs.getDate("cfretroactivedate").getTime()); // ȡ
                String personid = rs.getString("FPERSONID"); // ȡԱID
                String cmpitemid = rs.getString("FCMPITEMID"); // ȡнʵĿID
                Date mainEffectday = new Date(rs.getDate("FEFFECTDAY").getTime()); // ȡнʵЧ
                Date mainLeffectday = rs.getDate("FLEFFECTDAY"); // ȡнʵʧЧ
                logger.error("dettaiRs-mainEffectday:"+mainEffectday+",leffectday:"+mainLeffectday); //ÿչ
                String mainleftdayYearMonth = DateTimeUtils.format(mainEffectday, "yyyy-MM"); // ʽЧΪ-¡
                String oldfixadjustsalaryid = rs.getString("foldfixadjustsalaryid"); // ȡɵнʵID
                String id = rs.getString("fid"); // ȡǰнʵ¼ID
                if (StringUtils.isNotBlank(oldfixadjustsalaryid)) {
                    String sqlOld = "\n" +
                            " SELECT FMONEY ,FID ,FPERSONID ,FCMPITEMID,FEFFECTDAY ,FLEFFECTDAY,CFTraceability,CFRetroactiveDate,foldfixadjustsalaryid \n" +
                            " FROM T_HR_SFixAdjustSalary where fid ='" + oldfixadjustsalaryid + "' ";
                    logger.error("sqlOld================================= " + sqlOld);
                    IRowSet dettaiRs = DbUtil.executeQuery(ctx, sqlOld); // ִSQLѯȡ
                    String detialid;
                    if (dettaiRs.next()) {
                        detialid = dettaiRs.getString("fid"); // ȡӲѯ¼ID
                        logger.error("start detialid================================= " + detialid); // ¼Ӳѯ¼ID־
                        BigDecimal detailMony = dettaiRs.getBigDecimal("FMONEY"); // ȡӲѯ¼нʵ 10000
                        logger.error("dettaiRsretMoney " + detailMony); // ¼Ӳѯ¼нʵ־
                        BigDecimal retMoney = money.subtract(detailMony); // н
                        logger.error("retMoney " + retMoney); // ¼нʵ־ 2000
                        Date effectday = dettaiRs.getDate("FEFFECTDAY"); // ȡӲѯ¼Ч
                        Date leffectday = dettaiRs.getDate("FLEFFECTDAY"); // ȡӲѯ¼ʧЧ
                        logger.error("dettaiRs-effectday:"+effectday+",leffectday:"+leffectday); //ÿչ
                        //ȡ·ݲ
                        List<String> stringList = this.getMonthBetweenDate_V1(mainEffectday,cfretroactivedate);
                        //ȡʼ
                        Calendar cal = Calendar.getInstance();
                        cal.setTime(mainEffectday);
                        cal.set(Calendar.DAY_OF_MONTH, 1);
                        String startDate = DateTimeUtils.format(cal.getTime(), "yyyy-MM-dd");
                        //
                        boolean endBool=false;
                        Calendar cal2 = Calendar.getInstance();
                        cal2.setTime(cfretroactivedate);
                        if(cal2.get(Calendar.DAY_OF_MONTH)>1){
                            cal2.add(Calendar.MONTH, 1);
                            endBool=true;
                        }
                        cal2.set(Calendar.DAY_OF_MONTH, 1);
                        cal2.add(Calendar.DAY_OF_MONTH, -1);

                        String endDate = DateTimeUtils.format(cal2.getTime(), "yyyy-MM-dd");
                        //Ч
                        String leffectDate = endDate;
                        if(endBool){
                            leffectDate = DateTimeUtils.format(cfretroactivedate, "yyyy-MM-dd");
                        }
                        //Ч
                        String effectDate = DateTimeUtils.format(mainEffectday, "yyyy-MM-dd");

                        StringBuilder sqlDay = new StringBuilder();
                        sqlDay.append(" select to_char(wItem.fdate,'yyyy-MM-dd') from T_HR_ATS_WORKCALENDARITEM wItem ");
                        sqlDay.append(" left join T_HR_ATS_WORKCALENDAR w on w.fid=wItem.fcalendargroupid ");
                        sqlDay.append(" left join ( ");
                        sqlDay.append("     select fcalendarid from T_HR_ATS_ATTENDANCEFILE ");
                        sqlDay.append("     where fproposerid = ? ");
                        sqlDay.append("     order by fleffdt desc ");
                        sqlDay.append(" ) cal on cal.fcalendarid=w.fid ");
                        sqlDay.append(" where wItem.fweek not in(0,6) ");
                        sqlDay.append(" and to_char(wItem.fdate,'yyyy-MM-dd') >= ? ");
                        sqlDay.append(" and to_char(wItem.fdate,'yyyy-MM-dd') <= ? ");
                        sqlDay.append(" order by wItem.fdate desc ");
                        logger.error("sqlDay:" + sqlDay.toString()); //ÿչ

                        //ÿµһҪÿ·ֿ
                        for(String yearMonth : stringList) {
                            startDate=yearMonth+"-01";
                            Calendar endCal = Calendar.getInstance();
                            endCal.setTime(DateTimeUtils.parseDate(startDate));
                            endCal.add(Calendar.MONTH, 1);
                            endCal.add(Calendar.DAY_OF_MONTH, -1);
                            endDate=DateTimeUtils.format(endCal.getTime(), "yyyy-MM-dd");;

                            logger.error("sqlDay-param:personid:" + personid+",startDate:"+startDate+",endDate:"+endDate); //ÿչ
                            IRowSet dayRs1 = DbUtil.executeQuery(ctx, sqlDay.toString(), new String[]{personid, startDate, endDate}); // ִSQLѯȡ

                            BigDecimal days1 = BigDecimal.ZERO;
                            if (dayRs1.next()) {
                                days1 = new BigDecimal(dayRs1.size());
                            }
                            BigDecimal days2 = BigDecimal.ZERO;
                            String startDate2=startDate.compareTo(effectDate)>0?startDate:effectDate;
                            String endDate2=endDate.compareTo(leffectDate)>0?leffectDate:endDate;
                            logger.error("sqlDay-param:personid:" + personid+",effectDate:"+effectDate+",endDate:"+endDate); //ÿչ
                            logger.error("sqlDay-param:personid:" + personid+",startDate2:"+startDate2+",endDate2:"+endDate2); //ÿչ
                            IRowSet dayRs2 = DbUtil.executeQuery(ctx, sqlDay.toString(),new String[]{personid,startDate2,endDate2}); // ִSQLѯȡ
                            if (dayRs2.next()){
                                days2= new BigDecimal(dayRs2.size());
                            }
                            logger.error("sumMoney-days1:" + days1); //ÿչ
                            logger.error("sumMoney-days2:" + days2); //ÿչ
                            logger.error("sumMoney:" + sumMoney); //ÿչ
                            if(days1.compareTo(BigDecimal.ZERO) > 0) {
                                BigDecimal dayMoney = retMoney.divide(days1,BigDecimal.ROUND_HALF_UP,BigDecimal.ROUND_HALF_UP);
                                logger.error("sumMoney-day:" + dayMoney); //ÿչ
                                sumMoney = sumMoney.add(dayMoney.multiply(days2));
                                logger.error("sumMoney-days:" + sumMoney); //㹤
                            }else {
                                sumMoney= sumMoney.add(BigDecimal.ZERO);
                            }
                        }

                        // SQL䣬ڼǷضԱн֧¼
                        String exiSql = "select * from CT_CUS_PersonPayForm where CFPersonID ='" + personid + "' and CFAdjustSalary='" + id + "' ";
                        logger.error("exiSql sql " + exiSql); // ¼SQL䵽־
                        IRowSet extRs = DbUtil.executeQuery(ctx, exiSql); // ִSQLѯȡ

                        String insertSql;
                        // ΪҰ¼
                        if (extRs != null && extRs.size() > 0) {
                            // SQL䣬ڸԱн֧еĻн
                            insertSql = "/*dialect*/ update  CT_CUS_PersonPayForm set CFRetMoney=" + sumMoney.setScale(2, 4) +",CFMonth=to_date('" + DateTimeUtils.format(cfretroactivedate) + "','yyyy-MM-dd')"+ " where  CFAdjustSalary='" + id + "' ";
                            logger.error("updateSql " + insertSql); // ¼SQL䵽־
                            DbUtil.execute(ctx, insertSql); // ִSQL²
                        } else {
                            // Ϊջ򲻰¼
                            // SQL䣬Աн֧вµĻнʼ¼
                            insertSql = " /*dialect*/ insert into CT_CUS_PersonPayForm(fid,CFPersonID,CFMonth,CFRetMoney,cfadjustsalary) values(newbosid('5FB9A7AC'),'" + personid + "',to_date('" + DateTimeUtils.format(cfretroactivedate) + "','yyyy-MM-dd')" + "," + sumMoney.setScale(2, 5) + ",'" + id + "')";
                            logger.error("insertSql " + insertSql); // ¼SQL䵽־
                            DbUtil.execute(ctx, insertSql); // ִSQL
                        }
                    }
                }
            }
            String sft = "update CT_CUS_PersonPayForm set CFRetMoney=0 where CFAdjustSalary in(select fid from T_HR_SFixAdjustSalary where CFTraceability='No')";
            DbUtil.execute(ctx, sft); // ִSQL
        } catch (Exception e) {
            e.printStackTrace();
            throw new BOSException(e);
        }
        return null;
    }
    // ȡ֮·ݼ
    public static List<String> getMonthBetweenDate_V1(Date startTime, Date endTime) {
        List<String> list = new ArrayList<>();
        LocalDate startDate = startTime.toInstant()
                .atZone(ZoneId.systemDefault())
                .toLocalDate();
        LocalDate endDate = endTime.toInstant()
                .atZone(ZoneId.systemDefault())
                .toLocalDate();

        // ݺ·ݲֵ
        int startYear = startDate.getYear();
        int startMonth = startDate.getMonthValue();
        int endYear = endDate.getYear();
        int endMonth = endDate.getMonthValue();

        int yearDifference = endYear - startYear;
        int monthDifference = yearDifference * 12 + (endMonth - startMonth);

        //  endDate С startLocalDate ¸µĵһ죬ȥ 1
        LocalDate nextMonthFirstDay = startDate.plusMonths(monthDifference).withDayOfMonth(1);
        if (endDate.isBefore(nextMonthFirstDay)) {
            monthDifference--;
        }
        if (endDate.isAfter(nextMonthFirstDay)) {
            monthDifference++;
        }
        int month=0;
        do{
            month++;
            String monthStr =startMonth+"";
            if(startMonth<10){
                monthStr="0"+monthStr;
            }
            String yearMonth = startYear + "-" + monthStr;
            if(12==startMonth){
                startMonth=1;
                startYear=startYear+1;
            }else {
                startMonth++;
            }
            list.add(yearMonth);

        }while (month < monthDifference);
        return list;
    }

}
